<?php
/*
    Copyright 2007, 2008 University of Strathclyde
        
    This file is part of the SIMPLE Platform.

    The SIMPLE Platform is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The SIMPLE Platform is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the SIMPLE Platform.  If not, see <http://www.gnu.org/licenses/>.
    
*/    

/**
 * Language Handling Code
 * @author Michael Hughes
 * 
 * @package TLE2
 */
  function GetString($key,$forLanguage =null) {
    global $config;
    static $languageStrings;    //cached in memory
    $lang = $config['DEFAULT_LANGUAGE'];
    if (!is_null($forLanguage)) {
      //use a specific language pack
      $lang = $forLanguage;
    }
    if (empty($strings[$lang])) {
      $strings[] = array();
      include("lang/$lang/language.php");
      $languageStrings[$lang] = $strings;
    }
    else {
      $strings = &$languageStrings[$lang];
    }
    if (!isset($strings[$key])) {
       return $key.'(not defined)';
       //return false;
    }
    return $strings[$key];
  }
  function GetAllStrings($forLanguage=null) {
    global $config;
    $strings = array();
    static $languageStrings;    //cached in memory
    $lang = $config['DEFAULT_LANGUAGE'];
    if (!is_null($forLanguage)) {
      //use a specific language pack
//echo 'using specific';
      $lang = $forLanguage;
    }
    if (empty($strings[$lang])) {

      //$strings[] = array();
      $langpack = 'lang/'.$lang.'/language.php';
//echo 'loading strings: '.$langpack;
      include($langpack);
      $languageStrings[$lang] = $strings;
//print_r($strings);
    }
    else {
      //  echo 'using cached';
      $strings = &$languageStrings[$lang];
    }

    return $strings;
  }