<?php 
/**
 * @package Install
 */

/*
    Copyright 2007, 2008 University of Strathclyde
        
    This file is part of the SIMPLE Platform.

    The SIMPLE Platform is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    The SIMPLE Platform is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with the SIMPLE Platform.  If not, see <http://www.gnu.org/licenses/>.
    
*/

/* 
 * This filMDB2 is "required" into index.php and should only include the database 
 * creation steps. 
 */
 if (!defined('doDbCreate')) {
  die('This script should only be run as part of your installation. Running this
  script now will <b>destroy</b> any configured SIMPLE:plaform installation!');
 }
 
 
 require_once('MDB2.php') ;//r die('MDB2 is not installed!');
 $dsn = $_SESSION['setupinfo']['dbtype'].'://'.$_SESSION['setupinfo']['dbuser'].':'.$_SESSION['setupinfo']['dbpassword'].'@'.$_SESSION['setupinfo']['dbhost'].':'.$_SESSION['setupinfo']['dbport'];
  
 //construct the DSN from the user provided details
 /*
 		fwrite($configFile,'$config[DATABASE_TYPE] = \''.$_SESSION['setupinfo']['dbtype'].'\';');
		fwrite($configFile,'$config[DATABASE_HOST] = \''.$_SESSION['setupinfo']['dbhost'].'\';');
		fwrite($configFile,'$config[DATABASE_NAME] = \''.$_SESSION['setupinfo']['dbname'].'\';');
		fwrite($configFile,'$config[DATABASE_USERNAME] = \''.$_SESSION['setupinfo']['dbuser'].'\';');
		fwrite($configFile,'$config[DATABASE_PASSWORD] = \''.$_SESSION['setupinfo']['dbpassword'].'\';');
		*/


 //$mdb2 =& MDB2::factory($dsn);
  $mdb2 =& MDB2::connect($dsn);
// isError($mdb2);
 if (PEAR::isError($mdb2)) {
  print_r($mdb2);
  
  die($mdb2->getMessage());
 }
 $mdb2 =& MDB2::factory($dsn);
 
 $mdb2->loadModule('Manager');
 $dbname=$_SESSION['setupinfo']['dbname'];
 creating('<span style=\"color:red;background-color:yellow\">Dropped DB (this step should be removed from the live script!)</a>');
 $r = $mdb2->dropDatabase($dbname);
 if (PEAR::isError($r)) {
 // print_r($r);
 }
 
 isError($r); 
 
 creating('Database');
 $r =$mdb2->createDatabase($dbname);
 if (PEAR::isError($r)) {
 // print_r($r);
 }
 isError($r);
 
 creating('Selecting Created Database');
 $r= $mdb2->setDatabase($dbname);
 if (PEAR::isError($r)) {
  print_r($r);
 }
 isError($r);
 print_r($r);
 echo '<hr>';
 //System Authentication stuff
 //Create users table
 $usersOpts = array();
 $usersDef = array(
    'userid' => array('type'=>'integer','unsigned'=>1,'notnull'=>1),
    'username' => array('type'=>'text','length'=>100,'notnull'=>1),
    'password' => array('type'=>'text','length'=>100,'notnull'=>1),
    'displayname' => array('type'=>'text','length'=>200),
    'blurb' => array('type'=>'clob'),
    'active' => array('type'=>'boolean','default'=>1),
    'email' => array('type'=>'text','length'=>200),
    'regnumber' => array('type'=>'text','length'=>10),
    'properties' => array('type'=>'clob'),
    'superadmin' => array('type'=>'boolean','default'=>0),
    'salt' => array('type'=>'text'),
    'avatar' => array('type'=>'blob'),
    'imagetype' =>array('type'=>'text','length'=>20,'notnull'=>0),
    'deleted' => array('type'=>'boolean','default'=>0),
    'notifyonsend' => array('type'=>'boolean','default'=>1),
    'notifyonreceive' =>array('type'=>'boolean','default'=>1)
 );
 
 creating('Users table');
 $result = $mdb2->createTable('users',$usersDef,$usersOpts);
 if (PEAR::isError($result)) {
 echo '<pre>';
 print_r($result);
 echo '</pre>';
  die ($result->getMessage());
 }
 //users Primary Key
 $usersPk = array( 
    'primary'=>true,
    'fields'=> array(
      'userid'=>array()
    )
 );

 $result = $mdb2->createConstraint('users','usersPrimary',$usersPk);
 //Username Index (for quicker searching)
 $usersUserNameIndex = array(
    'fields'=>array(
      'username'=> array(),
      'password'=> array()
    )
 );
 creating('users');
 isError($mdb2->createIndex('users','userNameIndex',$usersUserNameIndex));
 creating('users sequence');
 $r =$mdb2->createSequence('users',0);
  if (PEAR::isError($r)){
  echo '<pre>';
  print_r($r);
  echo '</pre>';
  die();
 }
 isError($r);
 $r = null;
 
 //create usergroups table
 $usergroupsOpts = array();
 $usergroupsDef = array(
    'groupid'=> array('type'=>'integer','unsigned'=>1,'notnull'=>1),
    'name'=>array('type'=>'text','length'=>45,'notnull'=>1),
    'deleted'=>array('type'=>'integer','unsigned'=>1,'notnull'=>1,'default'=>0),
    'active'=>array('type'=>'integer','unsigned'=>1,'notnull'=>1,'default'=>1)
 );
 $usergroupsPk = array(
  'primary'=>true,
  'fields'=> array(
    'groupid'=>array()
  )
 );
 creating('usergroups');
 isError($mdb2->createTable('usergroups',$usergroupsDef,$usergroupsOpts));
 creating('usergroups PK');
 isError($mdb2->createConstraint('usergroups','userGroupPk',$usergroupsPk));
 creating('usergroupsSequence');
 $r = $mdb2->createSequence('usergroups',0);
 if (PEAR::isError($r)){
  echo '<pre>';
  print_r($r);
  echo '</pre>';
  die();
 }
 isError($r);
 
 
 //create userauth table
 $userauthOpts = array();
 $userauthDef = array(
    'authmethod'=> array('type'=>'text','length'=>100,'notnull'=>1),
    'externalid'=> array('type'=>'text','length'=>100,'notnull'=>1),
    'internalid'=> array('type'=>'integer','notnull'=>1,'unsigned'=>1),
    'deleted'=>array('type'=>'boolean','default'=>false)
 );

 $userauthPk = array(
  'primary'=>true,
  'fields'=> array(
    'authmethod'=>array(),
    'externalid'=>array(),
    'internalid'=>array()
  )
 );
creating('userauth'); 
 isError($mdb2->createTable('userauth',$userauthDef,$userauthOpts));
 creating('userauth');
 isError($mdb2->createConstraint('userauth','userAuthPk',$userauthPk));
 
 
 //create user2usergroup table
 $user2usergroupOpts = array();
 $user2usergroupDef = array( 
    'groupid'=>array('type'=>'integer','unsigned'=>true),
    'userid'=>array('type'=>'integer','unsigned'=>true),
    'deleted'=>array('type'=>'boolean','default'=>false)
 );
  $user2usergroupPk = array(
    'primary'=>true,
    'fields'=>array(
      'groupid'=>array(),
      'userid' =>array()
    )
  );
  creating('user2usergroup');
 $result = $mdb2->createTable('user2usergroup',$user2usergroupDef,$user2usergroupOpts);
 creating('user2usergroup');
 $result = $mdb2->createConstraint('user2usergroup','user2usergroupPk',$user2usergroupPk);
  
  
 //create sitewidepermissions table
  $swpOpts =array();
  $swpDef = array(
    'userid'=>array('type'=>'integer'),
    'usertype'=>array('type'=>'text','length'=>10,'default'=>'user','notnull'=>1),
    'adduser'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'edituser'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'makelevelzerouser'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'addplugin'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'installtemplate'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'edittemplate'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'removetemplate'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'usestafftools'=>array('type'=>'boolean','default'=>0,'notnull'=>1),
    'deleted'=>array('type'=>'boolean','default'=>0,'notnull'=>1)
  );
 $swpPk = array(
    'primary'=>true,
    'fields'=> array(
      'userid'=>array(),
      'usertype' => array()
    )
 );
 creating('sitewidepermissions');
 isError($mdb2->createTable('sitewidepermissions',$swpDef,$swpOpts));
 creating('sitewidepermissions');
 isError($mdb2->createConstraint('sitewidepermissions','sitewidepermissionsPk',$swpPk));
 
 
 //create plugins table
  $pluginsOpts = array();
  $pluginsDef = array(
    'pluginname'=>array('type'=>'text','length'=>100,'notnull'=>1),
    'pluginfile'=>array('type'=>'text','length'=>100),
    'pluginorder' => array('type'=>'integer','default'=>0),
    'enabled'=>array('type'=>'boolean','default'=>false),
    'sitewide'=>array('type'=>'boolean','default'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );
  $pluginsPk =array(
    'primary'=>true,
    'fields' =>array(
      'pluginname'=>array()
    )
  );
creating('plugins');
 isError($mdb2->createTable('plugins',$pluginsDef,$pluginsOpts));
creating('plugins PK');
 isError($mdb2->createConstraint('plugins','pluginsPk',$pluginsPk));
 
 
 //create metrics table
  $metricsOpts = array();
  $metricsDef = array(
    'id'=>array('type'=>'integer','notnull'=>1,'default'=>0),
    'projectid'=>array('type'=>'integer','notnull'=>0),
    'timestamp' => array('type'=>'text','length'=>50),
    'metricname'=>array('type'=>'text','length'=>100),
    'value'=>array('type'=>'clob'),
  );
  $metricsPk =array(
    'primary'=>true,
    'fields' =>array(
      'id'=>array()
    )
  );
 creating('metrics');
 isError( $mdb2->createTable('metrics',$metricsDef,$metricsOpts));
 creating('metricsPK');
 isError($mdb2->createConstraint('metrics','metricsPk',$metricsPk));
 creating('metrics Sequence');
 isError($mdb2->createSequence('metrics'));

//Start Blueprint related tables 
 //create containers table
 $containerOpts = array();
 $containerDef = array(
  'containerid' => array('type'=>'integer'),
  'name'=>array('type'=>'text','length'=>'45'),
  'deleted'=>array('type'=>'boolean','default'=>false)
 );
 $containerPk = array(
  'primary'=>true,
  'fields' => array(
    'containerid' => array()
  )
 );
 creating('containers');
 isError($mdb2->createTable('containers',$containerDef,$containerOpts));
 creating('containersOK');
 isError($mdb2->createConstraint('containers','containersPk',$containerPk));
 
 
 //create projecttemplates table
 $ptOpts = array();
 $ptDef = array(
  'projecttemplateuid'=>array('type'=>'integer'),
  'name'=>array('type'=>'text','length'=>100),
  'properties'=>array('type'=>'clob'),
  'variables'=>array('type'=>'clob'),
  'stylesheet'=>array('type'=>'clob'),
  'deleted'=>array('type'=>'boolean','default'=>false),
  'isactive'=>array('type'=>'boolean','default'=>true),
  'container'=>array('type'=>'text','length'=>255),
  'version'=>array('type'=>'integer','notnull'=>1,'default'=>0),
 );
 $ptPk = array(
  'primary'=>true,
  'fields'=> array(
    'projecttemplateuid'=>array()
  )
 );
creating('projecttemplates');
 isError($mdb2->createTable('projecttemplates',$ptDef,$ptOpts));
creating('projecttemplatesPK');
 isError($mdb2->createConstraint('projecttemplates','projecttemplatesPk',$ptPk));
creating('projecttemplatesSeq');
 isError($mdb2->createSequence('projecttemplates'));


  //create projecttemplateroles table
 $ptrOpts = array();
 $ptrDef = array(
  'id'=>array('type'=>'integer'),
  'projecttemplateid'=>array('type'=>'integer'),
  'projecttemplateroleid'=>array('type'=>'text','length'=>255),
  'rolename'=>array('type'=>'text','length'=>200),
  'namerule'=>array('type'=>'text','length'=>200),
  'addressrule'=>array('type'=>'text','length'=>200),
  'locationrule'=>array('type'=>'text','length'=>200),
  'directoryrule'=>array('type'=>'text','length'=>200),
  'properties'=>array('type'=>'clob'),
  'deleted'=>array('type'=>'boolean','default'=>false)
 );
 $ptrPk = array(
  'primary'=>true,
  'fields'=> array(
    'id'=>array()
  )
 );
creating('projecttemplateroles'); 
 isError($mdb2->createTable('projecttemplateroles',$ptrDef,$ptrOpts));
creating('projecttemplaterolesOK');
 isError($mdb2->createConstraint('projecttemplateroles','projecttemplaterolesPk',$ptrPk));
creating('projecttemplaterolesSeq');
 isError($mdb2->createSequence('projecttemplateroles'));


 //create projecttemplateplugins table
 $ptpOpts = array();
 $ptpDef = array(
  'projecttemplateuid'=>array('type'=>'integer'),
  'pluginname'=>array('type'=>'text','length'=>45),
  'enabled'=>array('type'=>'boolean','default'=>false),
  'deleted'=>array('type'=>'boolean','default'=>false)
 );
 $ptpPk = array(
  'primary'=>true,
  'fields'=> array(
    'projecttemplateuid'=>array(),
    'pluginname'=>array()
  )
 );
creating('projecttemplateplugins');
 isError($mdb2->createTable('projecttemplateplugins',$ptpDef,$ptpOpts));
creating('projecttemplateplugins');
 isError($mdb2->createConstraint('projecttemplateplugins','projecttemplatepluginsPk',$ptpPk));


 //create projecttemplatepermissions table
 $ptpermsOpts = array();
 $ptpermsDef = array(
  'userid'=>array('type'=>'integer','default'=>0,'notnull'=>1),
  'usertype'=>array('type'=>'text','length'=>10,'default'=>'user','notnull'=>1),
  'projecttemplateuid'=>array('type'=>'integer'),
  'editdocumenttemplate'=>array('type'=>'boolean','default'=>false),
  'archiveproject'=>array('type'=>'boolean','default'=>false),
  'startproject'=>array('type'=>'boolean','default'=>false),
  'endproject'=>array('type'=>'boolean','default'=>false),
  'edittemplate'=>array('type'=>'boolean','default'=>false),
  'viewtemplate'=>array('type'=>'boolean','default'=>false),
  'editplugin'=>array('type'=>'boolean','default'=>false),
  'changeuserpermissions'=>array('type'=>'boolean','default'=>false),
  'deleted'=>array('type'=>'boolean','default'=>false)
 );
 $ptpermsPk = array(
  'primary'=>true,
  'fields'=> array(
    'userid'=>array(),
    'usertype'=>array(),
    'projecttemplateuid'=>array()
  )
 );
 creating('projecttemplatepermissions');
 isError($mdb2->createTable('projecttemplatepermissions',$ptpermsDef,$ptpermsOpts));
 creating('projecttemplatepermissionsPK');
 $res = $mdb2->createConstraint('projecttemplatepermissions','projecttemplatepermissionsPk',$ptpermsPk);
 if (PEAR::isError($res)) {
  echo '<pre>';
  print_r($res);
  echo '</pre>';
 }
 
 
 //create projectsequence table
 
 $ptseqOpts = array();
 $ptseqDef = array(
  'id' =>array('type'=>'integer','unsigned'=>1),
  'projecttemplateid'  =>array('type'=>'integer','unsigned'=>1),
  'projecttemplateeventid' =>array('type'=>'text','length'=>40),
  'name' =>array('type'=>'text','length'=>'100'),
  'itemtype' =>array('type'=>'integer','unsigned'=>1),
  'performerrole' =>array('type'=>'text','length'=>'255'),
  'nexteventid' =>array('type'=>'text','length'=>'40'),
  'previouseventid' =>array('type'=>'text','length'=>'40'),
  'deleted' =>array('type'=>'boolean','default'=>false)
 );
 $ptseqPk = array(
  'primary'=>true,
  'fields'=> array(
    'id'=>array(),
  )
 );
 $pseqIndex = array (
    'fields' =>array(
      'projecttemplateid' =>array(),
      'projecttemplateeventid'=>array()
    )
 );
 creating('P sequence table');
 isError($mdb2->createTable('projectsequence',$ptseqDef,$ptseqOpts));
 creating('PT sequence Primary Key');
 isError($mdb2->createConstraint('projectsequence','projectsequencePk',$ptseqPk));
 creating('ProjectSequence NED EventIndex');
 isError($mdb2->createIndex('projectsequence','ProjectSequenceIndex',$pseqIndex));
 creating('ProjectSequence Sequence');
 isError($mdb2->createSequence('projectsequence'));
 
 message('only another 15 odd tables to go!');
 
//create eventresources table
  $evtResOpts = array();
  $evtResDef = array(
    'eventresourceId' =>array('type'=>'integer','unsigned'=>true),
    'projecttemplateid' =>array('type'=>'integer','unsigned'=>true),
    'projecttemplateeventid'=>array('type'=>'text','length'=>20,'notnull'=>1),
    'projecttemplateresourceid'=>array('type'=>'text','length'=>200,'notnull'=>1),
    'fromrole'=>array('type'=>'text','length'=>45,'notnull'=>1),
    'torole' =>array('type'=>'text','length'=>45,'notnull'=>1),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $evtResPk = array(
    'primary'=>true,
    'fields' =>array(
      'eventresourceid'=>array()
    )
  );
  $evtResIndex =array(
    'fields'=>array(
      'projecttemplateid'=>array(),
      'projecttemplateeventid'=>array()
    )
  );
  creating('eventresources table');
  isError($mdb2->createTable('eventresources',$evtResDef,$evtResOpts));
  creating('eventresources Primary Key');
  isError($mdb2->createConstraint('eventresources','eventresourcesPk',$evtResPk));
  creating('eventresources Index');
  isError($mdb2->createIndex('eventresources','eventresourcesIndex',$evtResIndex));
  creating('eventresources Sequence');
  isError($mdb2->createSequence('eventresources'));
  
  
 //create documenttemplates table
  $docTemplOpts = array();
  $docTemplDef = array(
    'doctemplateuid' =>array('type'=>'integer','unsigned'=>true),
    'projecttemplateid' =>array('type'=>'integer','unsigned'=>true),
    'documentid'=>array('type'=>'text','length'=>200,'notnull'=>1),
    'filename'=>array('type'=>'text','length'=>200,'notnull'=>1),
    'visiblename'=>array('type'=>'text','length'=>200,'notnull'=>0),
    'contenttype'=>array('type'=>'text','length'=>200,'notnull'=>0),
    'content' =>array('type'=>'clob','notnull'=>0),
    'creatoruserid'=>array('type'=>'integer','notnull'=>1,'default'=>0),
    'icon'=>array('type'=>'text','length'=>100),
    'playercansee'=>array('type'=>'boolean','default'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $docTemplPk = array(
    'primary'=>true,
    'fields' =>array(
      'doctemplateuid'=>array()
    )
  );
  $docTemplIndex =array(
    'fields'=>array(
      'projecttemplateid'=>array(),
      'documentid'=>array()
    )
  );
  creating('documenttemplates table');
  isError($mdb2->createTable('documenttemplates',$docTemplDef,$docTemplOpts));
  creating('documenttemplates Primary Key');
  isError($mdb2->createConstraint('documenttemplates','documenttemplatesPk',$docTemplPk));
  creating('documenttemplates Index');
  isError($mdb2->createIndex('documenttemplates','documenttemplatesIndex',$docTemplIndex));
  creating('documenttemplates Sequence');
  isError($mdb2->createSequence('documenttemplates'));
  
  message('Reticulating Splines');
  
//Runtime Sim related tables 
 //create projects table
  $projectOpts = array();
  $projectDef = array(
    'projectuid' =>array('type'=>'integer','unsigned'=>true),
    'projecttemplateid' =>array('type'=>'integer','unsigned'=>true),
    'name'=>array('type'=>'text','length'=>100,'notnull'=>1),
    'inbox'=>array('type'=>'text','length'=>45,'notnull'=>1),
    'sentitems'=>array('type'=>'text','length'=>45,'notnull'=>1),
    'variables' =>array('type'=>'clob'),
    'isactive'=>array('type'=>'boolean','default'=>true),
    'stylesheet'=>array('type'=>'clob','default'=>null),
    'deleted'=>array('type'=>'boolean','default'=>false),
    'creatorid'=>array('type'=>'integer','length'=>10,'default'=>false),
    'createddate'=>array('type'=>'date')
  );  
  $projectPk = array(
    'primary'=>true,
    'fields' =>array(
      'projectuid'=>array()
    )
  );
  creating('projects table');
  isError($mdb2->createTable('projects',$projectDef,$projectOpts));
  creating('projects Primary Key');
  isError($mdb2->createConstraint('projects','projectPk',$projectPk));
  creating('projects Sequence');
  isError($mdb2->createSequence('projects'));
  
 //create projectvariables table
  $projectVarsOpts = array();
  $projectVarsDef = array(
    'projectid' =>array('type'=>'integer','unsigned'=>true),
    'rolename' =>array('type'=>'text','length'=>45),
    'value'=>array('type'=>'clob','notnull'=>1),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $projectVarsPk = array(
    'primary'=>true,
    'fields' =>array(
      'projectid'=>array(),
      'rolename'=>array()
    )
  );
  creating('projectvariables table');
  isError($mdb2->createTable('projectvariables',$projectVarsDef,$projectVarsOpts));
  creating('projectvariables Primary Key');
  isError($mdb2->createConstraint('projectvariables','projectvariablesPk',$projectVarsPk));
 
 //create project permissions table
  $projectpermissionsOpts = array();
  $projectpermissionsDef = array(
    'userid' =>array('type'=>'integer','unsigned'=>1),
    'usertype' =>array('type'=>'text','length'=>10),
    'projectid'=>array('type'=>'integer','notnull'=>1),
    'usestafftools'=>array('type'=>'boolean','default'=>false),
    'deleteanyitem'=>array('type'=>'boolean','default'=>false),
    'deleteitem'=>array('type'=>'boolean','default'=>true),
    'viewitem'=>array('type'=>'boolean','default'=>true),
    'additem'=>array('type'=>'boolean','default'=>true),
    'editanyitem'=>array('type'=>'boolean','default'=>false),
    'edititems'=>array('type'=>'boolean','default'=>true),
    'stopproject'=>array('type'=>'boolean','default'=>false),
    'editplugin'=>array('type'=>'boolean','default'=>false),
    'changeuserpermissions'=>array('type'=>'boolean','default'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $projectpermissionsPk = array(
    'primary'=>true,
    'fields' =>array(
      'userid'=>array(),
      'usertype'=>array(),
      'projectid'=>array()
    )
  );
  creating('projectpermissions table');
  isError($mdb2->createTable('projectpermissions',$projectpermissionsDef,$projectpermissionsOpts));
  creating('projectpermissionsress Primary Key');
  isError($mdb2->createConstraint('projectpermissions','projectpermissionsPk',$projectpermissionsPk));
  
 
 //create projectprogress table
  $projectProgOpts = array();
  $projectProgDef = array(
    'eventid' =>array('type'=>'text','length'=>40,'unsigned'=>true),
    'projectid' =>array('type'=>'integer','unsigned'=>1),
    'state'=>array('type'=>'text','length'=>45,'notnull'=>1),
    'color'=>array('type'=>'text','length'=>6,'notnull'=>1),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $projectProgPk = array(
    'primary'=>true,
    'fields' =>array(
      'eventid'=>array(),
      'projectid'=>array()
    )
  );
  creating('projectprogress table');
  isError($mdb2->createTable('projectprogress',$projectProgDef,$projectProgOpts));
  creating('projectprogress Primary Key');
  isError($mdb2->createConstraint('projectprogress','projectprogressPk',$projectProgPk));
  
  
 //create projectplugins table
  $projectpluginsOpts = array();
  $projectpluginsDef = array(
    'projectid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'pluginname' =>array('type'=>'text','length'=>45),
    'enabled'=>array('type'=>'boolean','default'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false),
  );  
  $projectpluginsPk = array(
    'primary'=>true,
    'fields' =>array(
      'projectid'=>array(),
      'pluginname'=>array()
    )
  );
  creating('projectplugins table');
  isError($mdb2->createTable('projectplugins',$projectpluginsDef,$projectpluginsOpts));
  creating('projectprogress Primary Key');
  isError($mdb2->createConstraint('projectplugins','projectpluginsPk',$projectpluginsPk));
  
 //create projectgroups table
  $projectgroupsOpts = array();
  $projectgroupsDef = array(
    'projectgroupid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'projectgroupname' =>array('type'=>'text','length'=>45),
    'members'=>array('type'=>'clob'),
    'creatorid'=>array('type'=>'integer','default'=>0,'length'=>10),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $projectgroupsPk = array(
    'primary'=>true,
    'fields' =>array(
      'projectgroupid'=>array(),
    )
  );
  creating('projectgroups table');
  isError($mdb2->createTable('projectgroups',$projectgroupsDef,$projectgroupsOpts));
  creating('projectgroups Primary Key');
  isError($mdb2->createConstraint('projectgroups','projectgroupsPk',$projectgroupsPk));
  creating('projectgroups sequence');
  isError($mdb2->createSequence('projectgroups'));
  
 //create folders table
  $foldersOpts = array();
  $foldersDef = array(
    'folderid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'projectid' =>array('type'=>'integer','length'=>10,'unsigned'=>true,'notnull'=>1),
    'name'=>array('type'=>'clob','notnull'=>1),
    'allowdeletes'=>array('type'=>'boolean','default'=>false),
    'additem'=>array('type'=>'boolean','default'=>false),
    'canbedeleted'=>array('type'=>'boolean','default'=>false),
    'icon'=>array('type'=>'text','length'=>255),
    'trashcan'=>array('type'=>'boolean','default'=>false,'notnull'=>0),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $foldersPk = array(
    'primary'=>true,
    'fields' =>array(
      'folderid'=>array(),
    )
  );
  creating('folders table');
  isError($mdb2->createTable('folders',$foldersDef,$foldersOpts));
  creating('folders Primary Key');
  isError($mdb2->createConstraint('folders','foldersPk',$foldersPk));
  creating('folders sequence');
  isError($mdb2->createSequence('folders'));
 
 //create documents table
  $documentsOpts = array();
  $documentsDef = array(
    'documentuid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'folderid' =>array('type'=>'integer','length'=>10,'notnull'=>1),
    'filename'=>array('type'=>'text','length'=>200,'notnull'=>1),
    'icon'=>array('type'=>'text','length'=>200,'default'=>false),
    'content'=>array('type'=>'clob','notnull'=>0),
    'contenttype'=>array('type'=>'text','length'=>200),
    'sender'=>array('type'=>'text','length'=>200,'default'=>''),
    'recipient'=>array('type'=>'text','length'=>200,'default'=>''),
    'timestamp'=>array('type'=>'text','length'=>20),
    'hidden'=>array('type'=>'boolean','default'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $documentsPk = array(
    'primary'=>true,
    'fields' =>array(
      'documentuid'=>array(),
    )
  );
  $documentsIndex = array (
    'fields' =>array(
      'folderid' =>array()      
    )
 );
  creating('documents table');
  isError($mdb2->createTable('documents',$documentsDef,$documentsOpts));
  creating('documents Primary Key');
  isError($mdb2->createConstraint('documents','documentsPk',$documentsPk));
  creating('documents folderidIndex');
  isError($mdb2->createIndex('documents','Index_2',$documentsIndex));
  creating('documents sequence');
  isError($mdb2->createSequence('documents'));
  
 // create directory table
   $directoryOpts = array();
  $directoryDef = array(
    'directoryid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'projectid'=>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'name'=>array('type'=>'text','length'=>255,'notnull'=>0),
    'address'=>array('type'=>'text','length'=>255,'notnull'=>0),
    'location'=>array('type'=>'text','length'=>255,'notnull'=>0),
    'directoryvisible'=>array('type'=>'text','length'=>255,'notnull'=>0,'default'=>1),
    'vrvisible'=>array('type'=>'text','length'=>255,'notnull'=>0,'default'=>1),
    'projectrole'=>array('type'=>'text','length'=>255,'notnull'=>0),
    'linkedprojects'=>array('type'=>'text','length'=>255),
    'properties'=>array('type'=>'clob'),
    'deleted'=>array('type'=>'boolean','default'=>false)
  );  
  $directoryPk = array(
    'primary'=>true,
    'fields' =>array(
      'directoryid'=>array(),
    )
  );
  creating('directory table');
  isError($mdb2->createTable('directory',$directoryDef,$directoryOpts));
  creating('directory Primary Key');
  isError($mdb2->createConstraint('directory','directoryPk',$directoryPk));
  creating('directory sequence');
  isError($mdb2->createSequence('directory'));
 
 //create commentary table
  $commentaryOpts = array();
  $commentaryDef = array(
    'commentid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'userid'=>array('type'=>'integer','length'=>11),
    'subject'=>array('type'=>'text','length'=>200),
    'comment'=>array('type'=>'clob'),
    'itemtype'=>array('type'=>'text','length'=>10),
    'itemid'=>array('type'=>'integer','length'=>11),
    'commentcreated'=>array('type'=>'timestamp'),
    'deleted'=>array('type'=>'boolean','default'=>false),
    'admincomment'=>array('type'=>'boolean','default'=>false),
    'displayname'=>array('type'=>'text','length'=>45)
  );  
  $commentaryPk = array(
    'primary'=>true,
    'fields' =>array(
      'commentid'=>array(),
    )
  );
  $ItemLookup= array(
    'fields'=>array(
      'itemtype'=>array(),
      'itemid'=>array()
    )
  );
  creating('commentary table');
  isError($mdb2->createTable('commentary',$commentaryDef,$commentaryOpts));
  creating('commentary Primary Key');
  isError($mdb2->createConstraint('commentary','commentaryPk',$commentaryPk));
  creating('commentary item lookup index');
  isError($mdb2->createIndex('commentary','itemlookup',$ItemLookup));
  creating('commentary sequence');
  isError($mdb2->createSequence('commentary'));
  
 //create calendarassignments table
  $calendarassignmentsOpts = array();
  $calendarassignmentsDef = array(
    'calitemid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'userid'=>array('type'=>'integer','length'=>11),
    'assignmentid'=>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'deleted'=>array('type'=>'boolean','default'=>false),
  );  
  $calendarassignmentsPk = array(
    'primary'=>true,
    'fields' =>array(
      'assignmentid'=>array(),
    )
  );
  $ItemIndex =array(
    'fields'=>array(
      'calItemId'=>array(),
    )
  );
  creating('calendarassignments table');
  isError($mdb2->createTable('calendarassignments',$calendarassignmentsDef,$calendarassignmentsOpts));
  creating('calendarassignments Primary Key');
  isError($mdb2->createConstraint('calendarassignments','calendarassignmentsPk',$calendarassignmentsPk));
  creating('calendarassignments item lookup index');
  isError($mdb2->createIndex('calendarassignments','ItemIndex',$ItemIndex));
  creating('calendarassignments sequence');
  isError($mdb2->createSequence('calendarassignments'));

 //create calendar table
  $calendarOpts = array();
  $calendarDef = array(
    'id' =>array('type'=>'integer','length'=>11,'unsigned'=>true),
    'projectid' =>array('type'=>'integer','length'=>11,'unsigned'=>false),
    'title'=>array('type'=>'text','length'=>200),
    'content'=>array('type'=>'clob'),
    'createddate'=>array('type'=>'text','length'=>20,'notnull'=>false),
    'createdby' =>array('type'=>'integer','length'=>11,'unsigned'=>true,'notnull'=>false),
    'startdate'=>array('type'=>'text','length'=>20),
    'enddate'=>array('type'=>'text','length'=>20),
    'istask'=>array('type'=>'boolean','default'=>false),
    'location'=>array('type'=>'text','length'=>200,'notnull'=>false),
    'alarmdelta'=>array('type'=>'text','length'=>20,'notnull'=>false),
    'deleted'=>array('type'=>'boolean','default'=>false),
    'completed'=>array('type'=>'boolean','default'=>false)
  );  
  $calendarPk = array(
    'primary'=>true,
    'fields' =>array(
      'id'=>array(),
    )
  );

  creating('calendar table');
  isError($mdb2->createTable('calendar',$calendarDef,$calendarOpts));
  creating('calendar Primary Key');
  isError($mdb2->createConstraint('calendar','calendarPk',$calendarPk));
  creating('calendar sequence');
  isError($mdb2->createSequence('calendar'));
 
 //create alerts table
  $alertsOpts = array();
  $alertsDef = array(
    'alertid' =>array('type'=>'integer','unsigned'=>true),
    'itemid' =>array('type'=>'integer','unsigned'=>true),
    'itemtype'=>array('type'=>'text','length'=>45),
    'message'=>array('type'=>'clob'),
    'userid'=>array('type'=>'integer','unsigned'=>true),
    'alerttime' =>array('type'=>'timestamp'),
    'ext_notified'=>array('type'=>'boolean','default'=>false),
    'state'=>array('type'=>'integer','unsigned'=>true),
    'deleted'=>array('type'=>'boolean','default'=>false),
    'title'=>array('type'=>'text','length'=>100,'default'=>false)
  );  
  $alertsPk = array(
    'primary'=>true,
    'fields' =>array(
      'alertid'=>array()
    )
  );
print_r($alertsDef);
  creating('alerts table');
  isError($mdb2->createTable('alerts',$alertsDef,$alertsOpts));	
  creating('alerts Primary Key');
  isError($mdb2->createConstraint('alerts','alertsPk',$alertsPk));
  creating('alerts sequence');
  isError($mdb2->createSequence('alerts'));

//create itemlinks table
  $itemlinksOpts = array();
  $itemlinksDef = array(
    'id' =>array('type'=>'integer','unsigned'=>true),
    'sourceitemtype' =>array('type'=>'text','length'=>10),
    'sourceitemid'=>array('type'=>'integer'),
    'destitemtype'=>array('type'=>'text','length'=>10),
    'destitemid'=>array('type'=>'integer'),
  );  
  $itemlinksPk = array(
    'primary'=>true,
    'fields' =>array(
      'id'=>array()
    )
  );

  creating('itemlinks table');
  isError($mdb2->createTable('itemlinks',$itemlinksDef,$itemlinksOpts));
  creating('itemlinks Primary Key');
  isError($mdb2->createConstraint('itemlinks','itemlinksPk',$itemlinksPk));
  creating('itemlinks sequence');
  isError($mdb2->createSequence('itemlinks'));
 //create readitems table
  $readitemsOpts = array();
  $readitemsDef = array(
    'itemid' =>array('type'=>'integer','length'=>10,'unsigned'=>true),
    'itemtype' =>array('type'=>'text','length'=>10),
    'userid'=>array('type'=>'integer','unsigned'=>10),
    'isread'=>array('type'=>'boolean','default'=>false),
  );  
  $readitemsPk = array(
    'primary'=>true,
    'fields' =>array(
      'itemid'=>array(),
      'itemtype'=>array(),
      'userid'=>array()
    )
  );

  creating('readitems table');
  isError($mdb2->createTable('readitems',$readitemsDef,$readitemsOpts));
  creating('readitems Primary Key');
  isError($mdb2->createConstraint('readitems','readitemsPk',$readitemsPk));

$userprefsOpts = array();
$userprefsDef = array(
    'userid'=>array('type'=>'integer','unsigned'=>true),
    'prefname'=>array('type'=>'text', 'length'=>45),
    'value'=>array('type'=>'text','length'=>100)
);
$userprefsPk = array(
    'primary'=>true,
    'fields' => array(
        'userid'=>array(),
        'prefname'=>array()
    )
);


  creating('Userprefs table');
  isError($mdb2->createTable('userprefs',$userprefsDef,$userprefsOpts));
  creating('userprefs Primary Key');
  isError($mdb2->createConstraint('userprefs','userprefsPk',$userprefsPk));
//create taskassignments table
//is this needed?

//setup users
 message2('Creating super user account');
 $superID = $mdb2->nextID('users',false);
 if (PEAR::isError($superID)) {
  isError($superID);
  echo '<pre>';
  print_r($superID);
  echo '</pre>';
 }
 else {
  $super = "INSERT INTO users VALUES($superID, 'super', '6fce215b4eac5407a0b361eab55d1974', 'Super Admin','', 1, 'super@yourdomain.com', 0, '', 1, '833ee99cc2e2b2fe8b82ee7daf86aed9', '', '',0,0,0)";
  $mdb2->exec($super);
 }
 message('Phew! Completed');
 
 
 ?>
